"""
unit tests for module fileutils
squeleton generated by /home/syt/cvs_work/logilab/pyreverse/py2tests.py on Sep 08 at 09:1:31


Some file / file path manipulation utilities

"""
__revision__ = "$Id: unittest_fileutils.py,v 1.2 2003/09/09 12:51:02 syt Exp $"

import unittest
import sys
from os.path import join
from os import getcwd, linesep
from logilab.common.fileutils import *

try:
    DATA_DIR = join(dirname(__file__), 'data')
except:
    DATA_DIR = join(getcwd(), 'data')
    
class FirstleveldirectoryFunctionTest(unittest.TestCase):

    def test_known_values_first_level_directory(self):
        """return the first level directory of a path"""
        self.assertEqual(first_level_directory('truc/bidule/chouette'), 'truc', None)
        self.assertEqual(first_level_directory('/truc/bidule/chouette'), '/', None)

class RelativepathFunctionTest(unittest.TestCase):

    def test_known_values_relative_path(self):
        """return the first level directory of a path"""
        self.assertEqual(relative_path('toto/index.html', 'index.html'), '../index.html')
        self.assertEqual(relative_path('index.html', 'toto/index.html'), 'toto/index.html')
        self.assertEqual(relative_path('tutu/index.html', 'toto/index.html'), '../toto/index.html')
        self.assertEqual(relative_path('toto/index.html', '/index.html'), '/index.html')
        self.assertEqual(relative_path('/toto/index.html', '/index.html'), '/index.html')
        self.assertEqual(relative_path('index.html', 'index.html'), '')
        self.assertEqual(relative_path('/index.html', '/index.html'), '')

    def test_known_values_relative_path(self):
        """return the first level directory of a path, unresolveable cases"""
        self.assertRaises(UnresolvableError, relative_path, '/index.html', 'toto/index.html')
        
    def test_known_values_norm_read(self):
        """return the first level directory of a path, unresolveable cases"""
        data = norm_read(join(DATA_DIR,'newlines.txt'))
        self.assertEqual(data, linesep.join(['1', '2', '3', '']))

def suite():
    """return the unitest suite"""
    loader = unittest.TestLoader()
    testsuite = loader.loadTestsFromModule(sys.modules[__name__])
    return testsuite

def Run(runner=None):
    """run tests"""
    testsuite = suite()
    if runner is None:
        runner = unittest.TextTestRunner()
        # uncomment next line to write tests results in a file
        #runner.__init__(open('tests.log','w+'))    
    return runner.run(testsuite)
        
if __name__ == '__main__':
    Run()
